<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form ref="formRef" :model="formData" :rules="formRules" label-width="100px" v-loading="formLoading">
      <el-form-item label="产品ID" prop="productId">
        <el-input v-model="formData.productId" placeholder="请输入产品ID" />
      </el-form-item>
      <el-form-item label="产品类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择产品类型">
          <el-option v-for="item in productTypeOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="产品名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入产品名称" />
      </el-form-item>
      <el-form-item label="产品单位" prop="unit">
        <el-input v-model="formData.unit" placeholder="请输入产品单位" />
      </el-form-item>
      <el-form-item label="订阅等级" prop="level">
        <el-input v-model="formData.level" placeholder="请输入订阅等级" />
      </el-form-item>
      <el-form-item label="时长数值" prop="durationValue">
        <el-input v-model="formData.durationValue" placeholder="请输入时长数值" />
      </el-form-item>
      <el-form-item label="时长单位" prop="durationUnit">
        <el-input v-model="formData.durationUnit" placeholder="请输入时长单位" />
      </el-form-item>
      <el-form-item label="产品价格" prop="price">
        <el-input v-model="formData.price" placeholder="请输入产品价格" />
      </el-form-item>
      <el-form-item label="货币单位" prop="currency">
        <el-input v-model="formData.currency" placeholder="请输入货币单位" />
      </el-form-item>
      <el-form-item label="产品描述" prop="description">
        <el-input v-model="formData.description" placeholder="请输入产品描述" />
      </el-form-item>
      <el-form-item label="平台" prop="platform">
        <el-input v-model="formData.platform" placeholder="请输入平台" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker v-model="formData.createdAt" type="date" value-format="x" placeholder="选择创建时间" />
      </el-form-item>
      <el-form-item label="更新时间" prop="updatedAt">
        <el-date-picker v-model="formData.updatedAt" type="date" value-format="x" placeholder="选择更新时间" />
      </el-form-item>
      <el-form-item label="时长天数" prop="durationDays">
        <el-input v-model="formData.durationDays" placeholder="请输入时长天数" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ProductItemsApi, ProductItems } from '@/api/keyboard/productitems'

/** 内购商品 表单 */
defineOptions({ name: 'ProductItemsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  productId: undefined,
  type: undefined,
  name: undefined,
  unit: undefined,
  level: undefined,
  durationValue: undefined,
  durationUnit: undefined,
  price: undefined,
  currency: undefined,
  description: undefined,
  platform: undefined,
  createdAt: undefined,
  updatedAt: undefined,
  durationDays: undefined
})
const formRules = reactive({
  productId: [{ required: true, message: '产品ID不能为空', trigger: 'blur' }],
  type: [{ required: true, message: '产品类型不能为空', trigger: 'change' }],
  name: [{ required: true, message: '产品名称不能为空', trigger: 'blur' }],
  price: [{ required: true, message: '产品价格不能为空', trigger: 'blur' }],
  currency: [{ required: true, message: '货币单位不能为空', trigger: 'blur' }],
  durationDays: [{ required: true, message: '时长天数不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const productTypeOptions = [
  { label: '订阅', value: 'subscription' },
  { label: '内购', value: 'in-app-purchase' }
]

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ProductItemsApi.getProductItems(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ProductItems
    if (formType.value === 'create') {
      await ProductItemsApi.createProductItems(data)
      message.success(t('common.createSuccess'))
    } else {
      await ProductItemsApi.updateProductItems(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    productId: undefined,
    type: undefined,
    name: undefined,
    unit: undefined,
    durationValue: undefined,
    durationUnit: undefined,
    price: undefined,
    currency: undefined,
    description: undefined,
    platform: undefined,
    createdAt: undefined,
    updatedAt: undefined,
    durationDays: undefined
  }
  formRef.value?.resetFields()
}
</script>
